<?php declare(strict_types=1);

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

#[ORM\Table(name: 'fpu', schema: 'collection')]
#[ORM\Entity]
class Fpu {
	use GetSetTrait;

	#[ORM\Column(name: 'id', type: 'integer', nullable: FALSE)]
	#[ORM\Id]
	#[ORM\GeneratedValue(strategy: 'IDENTITY')]
	private int $id;

	#[ORM\ManyToOne(targetEntity: 'Brand', fetch: 'EAGER')]
	#[ORM\OrderBy(['name' => 'asc'])]
	#[ORM\JoinColumn(name: 'brand_id', referencedColumnName: 'id', nullable: FALSE)]
	private Brand $brand;

	#[ORM\ManyToOne(targetEntity: 'Socket', fetch: 'EAGER')]
	#[ORM\OrderBy(['name' => 'asc'])]
	#[ORM\JoinColumn(name: 'socket_id', referencedColumnName: 'id', nullable: FALSE)]
	private Socket $socket;

	#[ORM\Column(name: 'series', type: 'string', nullable: TRUE)]
	private ?string $series = '';

	#[ORM\Column(name: 'model', type: 'string')]
	private string $model;

	#[ORM\Column(name: 'clock_speed', type: 'integer')]
	private int $clockSpeed = 33;

	#[ORM\Column(name: 'count', nullable: FALSE, options: array('default' => 1))]
	private int $count = 1;

	#[ORM\Column(name: 'notes', type: 'text', nullable: TRUE)]
	private ?string $notes = '';
}
