<?php declare(strict_types=1);

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use Stringable;

#[ORM\Table(name: 'gpu_core', schema: 'collection')]
#[ORM\Entity]
class GpuCore implements Stringable {
	use GetSetTrait;

	#[ORM\Column(name: 'id', type: 'integer', nullable: FALSE)]
	#[ORM\Id]
	#[ORM\GeneratedValue(strategy: 'IDENTITY')]
	private int $id;

	#[ORM\ManyToOne(targetEntity: 'Brand', fetch: 'EAGER')]
	#[ORM\OrderBy(['name' => 'asc'])]
	#[ORM\JoinColumn(name: 'brand_id', referencedColumnName: 'id', nullable: FALSE)]
	private Brand $brand;

	#[ORM\Column(name: 'name')]
	private string $name;

	#[ORM\Column(name: 'variant', nullable: TRUE)]
	private ?string $variant;

	#[ORM\Column(name: 'generation_name', nullable: TRUE)]
	private string $generationName;

	#[ORM\Column(name: 'generation_link', nullable: TRUE)]
	private ?string $generationLink = '';

	#[ORM\Column(name: 'architecture', nullable: TRUE)]
	private string $architecture;

	#[ORM\Column(name: 'architecture_link', nullable: TRUE)]
	private string $architectureLink;

	#[ORM\Column(name: 'process_node', nullable: TRUE)]
	private ?int $processNode;

	public function __toString(): string
	{
		$name = ( ! empty($this->variant))
			? "$this->name ($this->variant)"
			: $this->name;

		return "$name - [$this->brand] $this->generationName";
	}
}
