<?php declare(strict_types=1);

namespace App\Form;

use App\Entity\{Brand, GpuCore};
use Doctrine\ORM\EntityRepository;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\{AbstractType, FormBuilderInterface};
use Symfony\Component\OptionsResolver\OptionsResolver;

class GPUCoreType extends AbstractType
{
	use BrandCategoryTrait;

    public function buildForm(FormBuilderInterface $builder, array $options): void
	{
        $builder
            ->add('brand', EntityType::class, [
                'class'         => Brand::class,
                'query_builder' => self::filterBrands('gpu_core'),
            ])
            ->add('name')
            ->add('variant')
            ->add('architecture')
            ->add('architectureLink')
            ->add('generationName')
            ->add('generationLink')
            ->add('processNode');
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => GpuCore::class,
        ]);
    }
}

