<?php declare(strict_types=1);

namespace App\Form;

use App\Entity\Lenses;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\{AbstractType, FormBuilderInterface};
use Symfony\Component\OptionsResolver\Exception\AccessException;

use Symfony\Component\OptionsResolver\OptionsResolver;

class LensesType extends AbstractType
{
    /**
     * {@inheritDoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder->add('brand')
            ->add('coatings')
            ->add('productLine')
            ->add('model')
            ->add('mount')
            ->add('imageSize', ChoiceType::class, [
                'choices' => [
                    'Small Format' => [
                        '35mm'      => '35mm',
                        'APS-C'     => 'APS-C',
                        'Micro 4/3' => 'Micro 4/3',
                    ],
                    'Medium Format' => [
                        '6x6'   => '6x6cm',
                        '6x4.5' => '6x4.5cm',
                        '4x4'   => '4x4cm',
                    ],
                ],
            ])
            ->add('minFStop')
            ->add('maxFStop')
            ->add('minFocalLength')
            ->add('maxFocalLength')
            ->add('serial')
            ->add('purchasePrice')
            ->add('notes')
            ->add('received')
            ->add('formerlyOwned')
            ->add('frontFilterSize')
            ->add('rearFilterSize')
            ->add('isTeleconverter')
            ->add('designElements')
            ->add('designGroups')
            ->add('apertureBlades');
    }

    /**
     * {@inheritDoc}
     *
     * @throws AccessException
     */
    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Lenses::class,
        ]);
    }

    /**
     * {@inheritDoc}
     */
    public function getBlockPrefix(): string
    {
        return 'camerabundle_lenses';
    }
}
