<?php

namespace App\Form;

use App\Entity\Socket;
use App\Enum\SocketTypeEnum;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\EnumType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class SocketType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('name')
            ->add('otherName')
            ->add('pinCount')
            ->add('type', EnumType::class,[
				'class' => SocketTypeEnum::class,
			])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Socket::class,
        ]);
    }
}
